//+------------------------------------------------------------------+
//|                                                  Velocity_v2.mq5 |
//|                                Copyright  2006, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
//----  
#property copyright "Copyright  2006, TrendLaboratory"
//----    
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property description ""

//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----        
#property indicator_buffers 2
//----    
#property indicator_plots   2
//+----------------------------------------------+
//|     |
//+----------------------------------------------+
#property indicator_level1  0
#property indicator_levelcolor clrBlue
#property indicator_levelstyle STYLE_SOLID
//+----------------------------------------------+
//|     1            |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_HISTOGRAM
//----       SlateGray 
#property indicator_color1  clrSlateGray
//----   1 -  
#property indicator_style1  STYLE_SOLID
//----    1  3
#property indicator_width1  3
//----    
#property indicator_label1  "Velocity_v2"
//+----------------------------------------------+
//|     2            |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_LINE
//----       Magenta 
#property indicator_color2  clrMagenta
//----   2 - 
#property indicator_style2  STYLE_SOLID
//----    2  2
#property indicator_width2  2
//----    
#property indicator_label2  "Signal Velocity_v2"
//+----------------------------------------------+
//|    CXMA                        |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+

//----    CMomentum  CAMA   SmoothAlgorithms.mqh
CMomentum Mom;
CXMA XMA1,XMA2,XMA3,XMA4;
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simpl Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   //TrendFollow_2 Price 
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint MomPeriod=1; // Momentum 

input Smooth_Method VelocityMethod=MODE_EMA; //  
input uint VelocityLength=8; //            
input int VelocityPhase=15; //  ,
                     // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    

input Smooth_Method SignMethod=MODE_EMA; // 
input uint SignLength=5; //                     
input int SignPhase=15; // ,
                     // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    

input Applied_price_ IPC=PRICE_CLOSE;// 
input int Shift=0; //       
//+----------------------------------------------+
//----   ,    
//      
double VelBuffer[],SignBuffer[];
//----      
int min_rates_1,min_rates_2,min_rates_3,min_rates_4,min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_1=int(MomPeriod);
   int res=XMA1.GetStartBars(VelocityMethod,VelocityLength,VelocityPhase);
   min_rates_2=min_rates_1+res;
   min_rates_3=min_rates_2+res;
   min_rates_4=min_rates_3+res;
   min_rates_total=min_rates_4+XMA1.GetStartBars(SignMethod,SignLength,SignPhase);;

//----    SignBuffer   
   SetIndexBuffer(0,VelBuffer,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----       1  1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    VelBuffer   
   SetIndexBuffer(1,SignBuffer,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//----       2  1
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"Velocity_v2");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----    
   int first;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=0; //      
     }
   else first=prev_calculated-1; //      

//----    
   for(int bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      double price=PriceSeries(IPC,bar,open,low,high,close);
      double mom=Mom.MomentumSeries(0,prev_calculated,rates_total,MomPeriod,price,bar,false);     
      double xmom=XMA1.XMASeries(min_rates_1,prev_calculated,rates_total,VelocityMethod,VelocityPhase,VelocityLength,mom,bar,false);
      double xxmom=XMA2.XMASeries(min_rates_2,prev_calculated,rates_total,VelocityMethod,VelocityPhase,VelocityLength,xmom,bar,false);
      double xxxmom=XMA3.XMASeries(min_rates_3,prev_calculated,rates_total,VelocityMethod,VelocityPhase,VelocityLength,xxmom,bar,false);
      VelBuffer[bar]=xxxmom;
      SignBuffer[bar]=XMA4.XMASeries(min_rates_4,prev_calculated,rates_total,SignMethod,SignPhase,SignLength,xxxmom,bar,false);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
